/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables;


import com.tabajara.base.Indexes;
import com.tabajara.base.Keys;
import com.tabajara.base.Public;
import com.tabajara.base.tables.records.ArduinoatuadorRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Arduinoatuador extends TableImpl<ArduinoatuadorRecord> {

    private static final long serialVersionUID = 779071823;

    /**
     * The reference instance of <code>public.arduinoatuador</code>
     */
    public static final Arduinoatuador ARDUINOATUADOR = new Arduinoatuador();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<ArduinoatuadorRecord> getRecordType() {
        return ArduinoatuadorRecord.class;
    }

    /**
     * The column <code>public.arduinoatuador.ardsenid</code>.
     */
    public final TableField<ArduinoatuadorRecord, Integer> ARDSENID = createField("ardsenid", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('arduinoatuador_ardsenid_seq'::regclass)", org.jooq.impl.SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>public.arduinoatuador.fkardid</code>.
     */
    public final TableField<ArduinoatuadorRecord, Integer> FKARDID = createField("fkardid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.arduinoatuador.fkatuid</code>.
     */
    public final TableField<ArduinoatuadorRecord, Integer> FKATUID = createField("fkatuid", org.jooq.impl.SQLDataType.INTEGER, this, "");

    /**
     * Create a <code>public.arduinoatuador</code> table reference
     */
    public Arduinoatuador() {
        this(DSL.name("arduinoatuador"), null);
    }

    /**
     * Create an aliased <code>public.arduinoatuador</code> table reference
     */
    public Arduinoatuador(String alias) {
        this(DSL.name(alias), ARDUINOATUADOR);
    }

    /**
     * Create an aliased <code>public.arduinoatuador</code> table reference
     */
    public Arduinoatuador(Name alias) {
        this(alias, ARDUINOATUADOR);
    }

    private Arduinoatuador(Name alias, Table<ArduinoatuadorRecord> aliased) {
        this(alias, aliased, null);
    }

    private Arduinoatuador(Name alias, Table<ArduinoatuadorRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, "");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return Public.PUBLIC;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.ARDUINOATUADOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<ArduinoatuadorRecord, Integer> getIdentity() {
        return Keys.IDENTITY_ARDUINOATUADOR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<ArduinoatuadorRecord> getPrimaryKey() {
        return Keys.ARDUINOATUADOR_PKEY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<ArduinoatuadorRecord>> getKeys() {
        return Arrays.<UniqueKey<ArduinoatuadorRecord>>asList(Keys.ARDUINOATUADOR_PKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<ArduinoatuadorRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<ArduinoatuadorRecord, ?>>asList(Keys.ARDUINOATUADOR__ARDUINOATUADOR_FKARDID_FKEY, Keys.ARDUINOATUADOR__ARDUINOATUADOR_FKATUID_FKEY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinoatuador as(String alias) {
        return new Arduinoatuador(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Arduinoatuador as(Name alias) {
        return new Arduinoatuador(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinoatuador rename(String name) {
        return new Arduinoatuador(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Arduinoatuador rename(Name name) {
        return new Arduinoatuador(name, null);
    }
}
